<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push({ name: 'Data' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Données
      </span>
    </div>
    <div class="top">
      <b-row>
        <b-col class="left-col">
        </b-col>
        <b-col class="right-col">
          <b-overlay
            id="overlay-background"
            :show="reloading"
            :variant="'white'"
            :opacity="0.9"
            :blur="'2px'"
            rounded="sm"
          >
            <template #overlay>
              <div class="d-flex align-items-center">
                <b-spinner small variant="success"></b-spinner>
              </div>
            </template>
            <button
              class="btn btn-success btn-lg"
              @click="updateTasksList"
            >
              Actualiser
            </button>
          </b-overlay>
        </b-col>
      </b-row>
    </div>
    <div class="custom-table">
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
      >
        <CustomTable
          :fields="tasksFields"
          :items="tasksItems"
          :routeTo="'TaskDetail'"
          :selectable="false"
          :allowDeletion="false"
          :sortFunction="GET_DASHBOARD_TASKS"
          @sorted="setTableSorted"
          @loading="setTableLoader"
        />
        <Pagination
          v-if="Math.ceil(dashboardTasksCount/50) > 1"
          :nbPages="Math.ceil(dashboardTasksCount/50)"
          @change-page="changeTablePage"
        />
      </b-overlay>
    </div>
  </div>
</template>

<script>
import CustomTable from '@/components/CustomTable.vue';
import Pagination from '@/components/Pagination.vue';

import { mapState, mapActions, mapMutations } from 'vuex';

export default {
  name: 'Tasks',

  components: {
    CustomTable,
    Pagination
  },

  data() {
    return {
      loading: false,
      reloading: false,
      tasksFields: [
        {
          key: 'ID',
          apiName: 'task_id',
          sortable: false,
          width: '20%',
          centered: false
        },
        {
          key: 'Fichier',
          apiName: 'single_file',
          sortable: false,
          width: '20%',
          centered: false
        },
        {
          key: 'Date de début',
          apiName: 'creation_date',
          sortable: false,
          width: '20%',
          centered: false
        },
        {
          key: 'Date de fin',
          apiName: 'stop_date',
          sortable: false,
          width: '20%',
          centered: false
        },
        {
          key: 'Etat',
          apiName: 'state',
          sortable: false,
          width: '20%',
          centered: true
        }
      ],
      tableSorted: {
        direction: null,
        field: null
      }
    }
  },

  computed: {
    ...mapState('dashboard', [
      'dashboardTasksCount',
      'dashboardTasksQueue'
    ]),
    tasksItems() {
      return this.dashboardTasksQueue.map( el => {
        return {
          id: el.id,
          'ID': el.task_id,
          'Fichier':
            el.backend_object && el.backend_object.single_file ?
              el.backend_object.single_file.split('/').slice(-1)[0] :
              ''
          ,
          'Date de début': el.creation_date ? new Date(el.creation_date).toLocaleString('fr-FR', {
            year: "2-digit",
            month: "numeric",
            day: "numeric",
            hour: '2-digit',
            minute: "2-digit",
            second: "2-digit"
          }) : null,
          'Date de fin': el.stop_date ? new Date(el.stop_date).toLocaleString('fr-FR', {
            year: "2-digit",
            month: "numeric",
            day: "numeric",
            hour: '2-digit',
            minute: "2-digit",
            second: "2-digit"
          }) : null,
          'Etat': el.state
        }
      })
    }
  },

  created() {
    if (this.dashboardTasksQueue.length === 0) {
      this.loading = true;
      this.GET_DASHBOARD_TASKS({
        ...this.tableSorted
      })
      .then(() => {
        this.loading = false;
      });
    }
  },

  mounted() {
    this.SET_RELOAD_INTERVAL_ID(setInterval(() => {
      this.updateTasksList('reload');
    }, process.env.VUE_APP_RELOAD_INTERVAL));
  },

  methods: {
    ...mapMutations(['SET_RELOAD_INTERVAL_ID']),
    ...mapActions('dashboard', [
      'GET_DASHBOARD_TASKS'
    ]),

    setTableLoader(e) {
      this.loading = e;
    },
    setTableSorted(e) {
      this.tableSorted = e;
    },

    changeTablePage(e) {
      this.GET_DASHBOARD_TASKS({
        ...this.tableSorted,
        page: e
      })
    },

    updateTasksList(mode) {
      if (mode === 'reload') {
        this.reloading = true;
      } else {
        this.loading = true;
      }
      this.GET_DASHBOARD_TASKS({
        ...this.tableSorted
      })
      .then(() => {
        if (mode === 'reload') {
          this.reloading = false;
        } else {
          this.loading = false;
        }
      })
    }
  }
}
</script>

